<script setup lang="ts">
   // import * as CallLib from '@/uni_modules/RongCloud-CallWrapper/lib/index.esm'
   import ToolbarItemContainer from '../toolbar-item-container/index.vue'
   import custom from '../../../../assets/icon/telephone-icon.svg'
   import videoIcon from '../../../../assets/icon/video-icon.svg'
   import { isUniFrameWork } from '../../../../utils/env'
   import { computed, ref } from 'vue'
   import { type IConversationModel } from '@tencentcloud/chat-uikit-engine-lite'

   // CallLib.init({});

   const props = withDefaults(
     defineProps<{
       /** 通话状态： 0 语音 1 视频 */
       type?: '0' | '1'
       /** 信息数据 */
       currentConversation?: IConversationModel
     }>(),
     {
       type: '0',
       currentConversation: () => ({} as IConversationModel)
     }
   )


   /** 语音通话状态 */
   const isType = computed(() => props.type === '0')

   const evaluateIcon = isType.value ? custom : videoIcon

   const emits = defineEmits(['onDialogPopupShowOrHide'])

   const container = ref()
   const closeDialog = () => {
     container?.value?.toggleDialogDisplay(false)
   }

   const onDialogShow = () => {
     console.log('弹出窗口', isType.value)
     console.log('弹出窗口', props.currentConversation)
     let targetId = props.currentConversation.userProfile.userID
     // emits('onDialogPopupShowOrHide', true)
     callOut('single', isType.value ? 'audio' : 'video', targetId)
   }

   function callOut(callSelect, mediaSelect, targetId) {
     console.log('callSelect: ', callSelect)
     console.log('mediaSelect: ', mediaSelect)
     console.log('targetId: ', targetId)
     //单聊音频
     if (callSelect === 'single' && mediaSelect === 'audio') {
       if (targetId === '') {
         uni.showToast({
           title: '请输入对方ID',
           icon: 'error',
           duration: 2000
         })
         return
       }
       callMsg(mediaSelect, targetId, callSelect)
     } else if (callSelect === 'single' && mediaSelect === 'video') {
       if (targetId === '') {
         uni.showToast({
           title: '请输入对方ID',
           icon: 'error',
           duration: 2000
         })
         return
       }
       //单聊视频
       callMsg(mediaSelect, targetId, callSelect)
     }
   }

   function callMsg(mediaSelect, targetId, callSelect) {
     console.log(targetId)
     console.log(mediaSelect)
     uni.setStorageSync('room-parameters', {
       callType: 'out',
       mediaType: mediaSelect,
       targetId: targetId,
       callSelect: callSelect
     })
     uni.navigateTo({
       url: '/pages/room/room'
     })
   }

   const onDialogClose = () => {
     console.log('关闭窗口')
     emits('onDialogPopupShowOrHide', false)
   }

   const onDial = () => {
     const data = props.currentConversation.userProfile
     // data.userID
     CallLib.enableMicrophone(true)
     CallLib.startSingleCall(data.userID, 0, '邀请您进行语音通话')
   }
</script>

<template>
  <ToolbarItemContainer
    ref="container"
    needBottomPopup
    :iconFile="evaluateIcon"
    :iconWidth="isUniFrameWork ? '34px' : '20px'"
    :iconHeight="isUniFrameWork ? '34px' : '20px'"
    :title="isType ? '语音通话' : '视频通话'"
    @onDialogShow="onDialogShow"
    @onDialogClose="onDialogClose"
  >
    <view class="box-index">
      <view class="top-icon">
        <uni-icons
          type="back"
          color="#ffffff"
          size="42rpx"
          @click.stop="closeDialog"
        ></uni-icons>
      </view>

      <button @click.stop="onDial">拨打</button>

      <button
        @click.stop="
          () => {
            CallLib.enableMicrophone(true)
            CallLib.accept()
          }
        "
      >
        接听
      </button>
    </view>
  </ToolbarItemContainer>
</template>

<style scoped lang="scss" src="./style/index.scss"></style>
